# Description: drop extra commas (which cause 'argument is missing, with no default' errors)
# Arguments: 
#   lst: a doList (see startDoList())
# Value: the same 'lst' with extra commas removed from the uiCode elements
#
dropExtraCommas = function(lst) {
  #browser()
  # get true order
  m = length(lst)
  Ord = c(1, rep(NA, m-1))
  for (i in 2:m) Ord[i] = lst[[Ord[i-1]]]$nextElement

  # fixup ui.r based on indenting pattern
  indentInOrder = sapply(lst[Ord], function(x) x$indent)
  toFix = Ord[which(indentInOrder[1:(m-1)] > indentInOrder[2:m])]
  for (i in toFix) {
    n = length(lst[[i]]$uiCode)
    nn = nchar(lst[[i]]$uiCode[n])
    lst[[i]]$uiCode[n] = substring(lst[[i]]$uiCode[n], 1, nn-1)
  }
    
  return(lst)
} # end dropExtraCommas()

